#ifndef _SNOWLEOPARDFIXES_H_
#define	_SNOWLEOPARDFIXES_H_

// none of the following are available on 10.6 or earlier
// so there's likely no need to test for the presence of them
// although it could certainly be done by wrapping each definition
// in an ifdef / endif block.

#ifdef HAVE_CONFIG_H
#include "config.h"
#endif

#include <stdio.h>  /* FILE */
#include <unistd.h>  /* ssize_t */

#ifndef	__cplusplus
#ifndef	_WCHAR_T
#define	_WCHAR_T
typedef	__darwin_wchar_t	wchar_t;
#endif	/* _WCHAR_T */
#endif	/* __cplusplus */



#ifdef __cplusplus
extern "C" {
#endif

extern size_t strnlen(const char *s, size_t maxlen);

#ifdef __cplusplus
}
#endif



#ifdef __cplusplus
extern "C" {
#endif

extern ssize_t getline(char **lineptr, size_t *n, FILE *stream);

#ifdef __cplusplus
}
#endif


#ifdef __cplusplus
extern "C" {
#endif

extern char *strndup(const char *s, size_t n);

#ifdef __cplusplus
}
#endif


#ifdef __cplusplus
extern "C" {
#endif

extern void *
memmem(const void *l, size_t l_len, const void *s, size_t s_len);

#ifdef __cplusplus
}
#endif

#ifdef __cplusplus
extern "C" {
#endif

extern wchar_t *
wcsdup(const wchar_t *s);

#ifdef __cplusplus
}
#endif




// replace missing O_CLOEXIT definition with 0, which works
// but does not replace the full function of that flag
// this is the commonly done fix in MacPorts (see gtk3, for example)
#ifndef O_CLOEXEC
#define O_CLOEXEC 0
#endif



#endif //_SNOWLEOPARDFIXES_H_
